<?php
/**
 * MessageApi
 * PHP version 5
 *
 * @category Class
 * @package  Fifa\ConnectServiceBus\Sdk\Api
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
/**
 *  Copyright 2016 SmartBear Software
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program. 
 * https://github.com/swagger-api/swagger-codegen 
 * Do not edit the class manually.
 */

namespace Fifa\ConnectServiceBus\Sdk\Api\Resource;

use \Fifa\ConnectServiceBus\Sdk\Api\Configuration;
use \Fifa\ConnectServiceBus\Sdk\Api\ApiClient;
use \Fifa\ConnectServiceBus\Sdk\Api\ApiException;
use \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer;

/**
 * MessageApi Class Doc Comment
 *
 * @category Class
 * @package  Fifa\ConnectServiceBus\Sdk\Api
 * @author   http://github.com/swagger-api/swagger-codegen
 * @license  http://www.apache.org/licenses/LICENSE-2.0 Apache Licene v2
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class MessageApi
{

    /**
     * API Client
     * @var \Fifa\ConnectServiceBus\Sdk\Api\ApiClient instance of the ApiClient
     */
    protected $apiClient;
  
    /**
     * Constructor
     * @param \Fifa\ConnectServiceBus\Sdk\Api\ApiClient|null $apiClient The api client to use
     */
    function __construct($apiClient = null)
    {
        if ($apiClient == null) {
            $apiClient = new ApiClient();
            $apiClient->getConfig()->setHost('https://fci-servicebus-int.azurewebsites.net');
        }
  
        $this->apiClient = $apiClient;
    }
  
    /**
     * Get API client
     * @return \Fifa\ConnectServiceBus\Sdk\Api\ApiClient get the API client
     */
    public function getApiClient()
    {
        return $this->apiClient;
    }
  
    /**
     * Set the API client
     * @param \Fifa\ConnectServiceBus\Sdk\Api\ApiClient $apiClient set the API client
     * @return MessageApi
     */
    public function setApiClient(ApiClient $apiClient)
    {
        $this->apiClient = $apiClient;
        return $this;
    }
  
    
    /**
     * messageCreateTopicByTopicname
     *
     * Creates a new topic for messages.
     *
     * @param string $topic_name The name of the topic to be created. (required)
     * @return \Fifa\ConnectServiceBus\Sdk\Api\Model\Object
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageCreateTopicByTopicname($topic_name)
    {
        list($response, $statusCode, $httpHeader) = $this->messageCreateTopicByTopicnameWithHttpInfo ($topic_name);
        return $response; 
    }


    /**
     * messageCreateTopicByTopicnameWithHttpInfo
     *
     * Creates a new topic for messages.
     *
     * @param string $topic_name The name of the topic to be created. (required)
     * @return Array of \Fifa\ConnectServiceBus\Sdk\Api\Model\Object, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageCreateTopicByTopicnameWithHttpInfo($topic_name)
    {
        
        // verify the required parameter 'topic_name' is set
        if ($topic_name === null) {
            throw new \InvalidArgumentException('Missing the required parameter $topic_name when calling messageCreateTopicByTopicname');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/createtopic";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($topic_name !== null) {
            $queryParams['topicName'] = $this->apiClient->getSerializer()->toQueryValue($topic_name);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams, '\Fifa\ConnectServiceBus\Sdk\Api\Model\Object'
            );
            
            if (!$response) {
                return array(null, $statusCode, $httpHeader);
            }

            return array(\Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($response, '\Fifa\ConnectServiceBus\Sdk\Api\Model\Object', $httpHeader), $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 200:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\Object', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageDeleteByRequestMessageidAndRequestLocktoken
     *
     * Deletes a previously locked message (see PeekLock method).
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteByRequestMessageidAndRequestLocktoken($message_id, $lock_token)
    {
        list($response, $statusCode, $httpHeader) = $this->messageDeleteByRequestMessageidAndRequestLocktokenWithHttpInfo ($message_id, $lock_token);
        return $response; 
    }


    /**
     * messageDeleteByRequestMessageidAndRequestLocktokenWithHttpInfo
     *
     * Deletes a previously locked message (see PeekLock method).
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteByRequestMessageidAndRequestLocktokenWithHttpInfo($message_id, $lock_token)
    {
        
        // verify the required parameter 'message_id' is set
        if ($message_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $message_id when calling messageDeleteByRequestMessageidAndRequestLocktoken');
        }
        // verify the required parameter 'lock_token' is set
        if ($lock_token === null) {
            throw new \InvalidArgumentException('Missing the required parameter $lock_token when calling messageDeleteByRequestMessageidAndRequestLocktoken');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/delete";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($message_id !== null) {
            $queryParams['messageId'] = $this->apiClient->getSerializer()->toQueryValue($message_id);
        }// query params
        
        if ($lock_token !== null) {
            $queryParams['lockToken'] = $this->apiClient->getSerializer()->toQueryValue($lock_token);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'DELETE',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageDeleteTemporaryTopics
     *
     * 
     *
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteTemporaryTopics()
    {
        list($response, $statusCode, $httpHeader) = $this->messageDeleteTemporaryTopicsWithHttpInfo ();
        return $response; 
    }


    /**
     * messageDeleteTemporaryTopicsWithHttpInfo
     *
     * 
     *
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteTemporaryTopicsWithHttpInfo()
    {
        
  
        // parse inputs
        $resourcePath = "/api/v3/message/deletetemporarytopics";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            }
  
            throw $e;
        }
    }
    
    /**
     * messageDeleteTopicByTopicname
     *
     * Deletes topic for messages
     *
     * @param string $topic_name  (required)
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteTopicByTopicname($topic_name)
    {
        list($response, $statusCode, $httpHeader) = $this->messageDeleteTopicByTopicnameWithHttpInfo ($topic_name);
        return $response; 
    }


    /**
     * messageDeleteTopicByTopicnameWithHttpInfo
     *
     * Deletes topic for messages
     *
     * @param string $topic_name  (required)
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageDeleteTopicByTopicnameWithHttpInfo($topic_name)
    {
        
        // verify the required parameter 'topic_name' is set
        if ($topic_name === null) {
            throw new \InvalidArgumentException('Missing the required parameter $topic_name when calling messageDeleteTopicByTopicname');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/deletetopic";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($topic_name !== null) {
            $queryParams['topicName'] = $this->apiClient->getSerializer()->toQueryValue($topic_name);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            }
  
            throw $e;
        }
    }
    
    /**
     * messagePeekLockByRequestTimeout
     *
     * Gets and locks a message without deleting it from the queue. If message is not deleted within configured time it's automatically unlocked and visible for other recipients.
     *
     * @param int $timeout The system will wait N number of seconds before returning \&quot;no messages available\&quot; message. (optional, default to 60)
     * @return object
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messagePeekLockByRequestTimeout($timeout = null)
    {
        list($response, $statusCode, $httpHeader) = $this->messagePeekLockByRequestTimeoutWithHttpInfo ($timeout);
        return $response; 
    }


    /**
     * messagePeekLockByRequestTimeoutWithHttpInfo
     *
     * Gets and locks a message without deleting it from the queue. If message is not deleted within configured time it's automatically unlocked and visible for other recipients.
     *
     * @param int $timeout The system will wait N number of seconds before returning \&quot;no messages available\&quot; message. (optional, default to 60)
     * @return Array of object, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messagePeekLockByRequestTimeoutWithHttpInfo($timeout = null)
    {
        
  
        // parse inputs
        $resourcePath = "/api/v3/message/peeklock";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($timeout !== null) {
            $queryParams['timeout'] = $this->apiClient->getSerializer()->toQueryValue($timeout);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams, 'object'
            );
            
            if (!$response) {
                return array(null, $statusCode, $httpHeader);
            }

            return array(\Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($response, 'object', $httpHeader), $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 201:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageReceiveByRequestTimeout
     *
     * Gets a message from the Message Bus. Message is deleted from the queue.
     *
     * @param int $timeout The system will wait N number of seconds before returning \&quot;no messages available\&quot; message. (optional, default to 60)
     * @return object
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageReceiveByRequestTimeout($timeout = null)
    {
        list($response, $statusCode, $httpHeader) = $this->messageReceiveByRequestTimeoutWithHttpInfo ($timeout);
        return $response; 
    }


    /**
     * messageReceiveByRequestTimeoutWithHttpInfo
     *
     * Gets a message from the Message Bus. Message is deleted from the queue.
     *
     * @param int $timeout The system will wait N number of seconds before returning \&quot;no messages available\&quot; message. (optional, default to 60)
     * @return Array of object, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageReceiveByRequestTimeoutWithHttpInfo($timeout = null)
    {
        
  
        // parse inputs
        $resourcePath = "/api/v3/message/receive";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($timeout !== null) {
            $queryParams['timeout'] = $this->apiClient->getSerializer()->toQueryValue($timeout);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'DELETE',
                $queryParams, $httpBody,
                $headerParams, 'object'
            );
            
            if (!$response) {
                return array(null, $statusCode, $httpHeader);
            }

            return array(\Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($response, 'object', $httpHeader), $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 200:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), 'object', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageRenewLockByRequestMessageidAndRequestLocktoken
     *
     * Extends the lock time for the previously locked message (see PeekLock method).
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageRenewLockByRequestMessageidAndRequestLocktoken($message_id, $lock_token)
    {
        list($response, $statusCode, $httpHeader) = $this->messageRenewLockByRequestMessageidAndRequestLocktokenWithHttpInfo ($message_id, $lock_token);
        return $response; 
    }


    /**
     * messageRenewLockByRequestMessageidAndRequestLocktokenWithHttpInfo
     *
     * Extends the lock time for the previously locked message (see PeekLock method).
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageRenewLockByRequestMessageidAndRequestLocktokenWithHttpInfo($message_id, $lock_token)
    {
        
        // verify the required parameter 'message_id' is set
        if ($message_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $message_id when calling messageRenewLockByRequestMessageidAndRequestLocktoken');
        }
        // verify the required parameter 'lock_token' is set
        if ($lock_token === null) {
            throw new \InvalidArgumentException('Missing the required parameter $lock_token when calling messageRenewLockByRequestMessageidAndRequestLocktoken');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/renewlock";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($message_id !== null) {
            $queryParams['messageId'] = $this->apiClient->getSerializer()->toQueryValue($message_id);
        }// query params
        
        if ($lock_token !== null) {
            $queryParams['lockToken'] = $this->apiClient->getSerializer()->toQueryValue($lock_token);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageSendByRecipientAndBodyAndActionAndProperties
     *
     * Sends a message to a specified recipient via Message Bus.
     *
     * @param string $recipient Recipient, usually MA to receive the message. (required)
     * @param ByteArray $body Message body (required)
     * @param string $x_action Name of the action. Optional parameter (optional)
     * @param string $x_properties Unencrypted properties of the message. Optional parameter (optional)
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageSendByRecipientAndBodyAndActionAndProperties($recipient, $body, $x_action = null, $x_properties = null)
    {
        list($response, $statusCode, $httpHeader) = $this->messageSendByRecipientAndBodyAndActionAndPropertiesWithHttpInfo ($recipient, $body, $x_action, $x_properties);
        return $response; 
    }


    /**
     * messageSendByRecipientAndBodyAndActionAndPropertiesWithHttpInfo
     *
     * Sends a message to a specified recipient via Message Bus.
     *
     * @param string $recipient Recipient, usually MA to receive the message. (required)
     * @param ByteArray $body Message body (required)
     * @param string $x_action Name of the action. Optional parameter (optional)
     * @param string $x_properties Unencrypted properties of the message. Optional parameter (optional)
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageSendByRecipientAndBodyAndActionAndPropertiesWithHttpInfo($recipient, $body, $x_action = null, $x_properties = null)
    {
        
        // verify the required parameter 'recipient' is set
        if ($recipient === null) {
            throw new \InvalidArgumentException('Missing the required parameter $recipient when calling messageSendByRecipientAndBodyAndActionAndProperties');
        }
        // verify the required parameter 'body' is set
        if ($body === null) {
            throw new \InvalidArgumentException('Missing the required parameter $body when calling messageSendByRecipientAndBodyAndActionAndProperties');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/send";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array('application/json','text/json','application/octet-stream'));
  
        // query params
        
        if ($recipient !== null) {
            $queryParams['recipient'] = $this->apiClient->getSerializer()->toQueryValue($recipient);
        }
        // header params
        
        if ($x_action !== null) {
            $headerParams['X-Action'] = $this->apiClient->getSerializer()->toHeaderValue($x_action);
        }// header params
        
        if ($x_properties !== null) {
            $headerParams['X-Properties'] = $this->apiClient->getSerializer()->toHeaderValue($x_properties);
        }
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        // body params
        $_tempBody = null;
        if (isset($body)) {
            $_tempBody = $body;
        }
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'POST',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
    /**
     * messageUnlockByRequestMessageidAndRequestLocktoken
     *
     * Unlocks a previously locked message. The message is returned to the queue and can be fetched using PeekLock or Receive method.
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return void
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageUnlockByRequestMessageidAndRequestLocktoken($message_id, $lock_token)
    {
        list($response, $statusCode, $httpHeader) = $this->messageUnlockByRequestMessageidAndRequestLocktokenWithHttpInfo ($message_id, $lock_token);
        return $response; 
    }


    /**
     * messageUnlockByRequestMessageidAndRequestLocktokenWithHttpInfo
     *
     * Unlocks a previously locked message. The message is returned to the queue and can be fetched using PeekLock or Receive method.
     *
     * @param string $message_id Message identifier returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @param string $lock_token Lock token, returned by a previously called \&quot;peeklock\&quot; method. (required)
     * @return Array of null, HTTP status code, HTTP response headers (array of strings)
     * @throws \Fifa\ConnectServiceBus\Sdk\Api\ApiException on non-2xx response
     */
    public function messageUnlockByRequestMessageidAndRequestLocktokenWithHttpInfo($message_id, $lock_token)
    {
        
        // verify the required parameter 'message_id' is set
        if ($message_id === null) {
            throw new \InvalidArgumentException('Missing the required parameter $message_id when calling messageUnlockByRequestMessageidAndRequestLocktoken');
        }
        // verify the required parameter 'lock_token' is set
        if ($lock_token === null) {
            throw new \InvalidArgumentException('Missing the required parameter $lock_token when calling messageUnlockByRequestMessageidAndRequestLocktoken');
        }
  
        // parse inputs
        $resourcePath = "/api/v3/message/unlock";
        $httpBody = '';
        $queryParams = array();
        $headerParams = array();
        $formParams = array();
        $_header_accept = ApiClient::selectHeaderAccept(array('application/json', 'text/json'));
        if (!is_null($_header_accept)) {
            $headerParams['Accept'] = $_header_accept;
        }
        $headerParams['Content-Type'] = ApiClient::selectHeaderContentType(array());
  
        // query params
        
        if ($message_id !== null) {
            $queryParams['messageId'] = $this->apiClient->getSerializer()->toQueryValue($message_id);
        }// query params
        
        if ($lock_token !== null) {
            $queryParams['lockToken'] = $this->apiClient->getSerializer()->toQueryValue($lock_token);
        }
        
        
        // default format to json
        $resourcePath = str_replace("{format}", "json", $resourcePath);

        
        
  
        // for model (json/xml)
        if (isset($_tempBody)) {
            $httpBody = $_tempBody; // $_tempBody is the method argument, if present
        } elseif (count($formParams) > 0) {
            $httpBody = $formParams; // for HTTP post (form)
        }
        
        // this endpoint requires OAuth (access token)
        if (strlen($this->apiClient->getConfig()->getAccessToken()) !== 0) {
            $headerParams['Authorization'] = 'Bearer ' . $this->apiClient->getConfig()->getAccessToken();
        }
        
        // make the API Call
        try {
            list($response, $statusCode, $httpHeader) = $this->apiClient->callApi(
                $resourcePath, 'PUT',
                $queryParams, $httpBody,
                $headerParams
            );
            
            return array(null, $statusCode, $httpHeader);
            
        } catch (ApiException $e) {
            switch ($e->getCode()) { 
            case 400:
                $data = \Fifa\ConnectServiceBus\Sdk\Api\ObjectSerializer::deserialize($e->getResponseBody(), '\Fifa\ConnectServiceBus\Sdk\Api\Model\BadRequestResponseType', $e->getResponseHeaders());
                $e->setResponseObject($data);
                break;
            }
  
            throw $e;
        }
    }
    
}
